Sunburst from Drilldown in JavaScript

Using ApexCharts with JavaScript

This Sunburst from Drilldown example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// A sunburst reads the SAME `series` + `drilldown.series` config a drilldown
// donut uses, so an existing drilldown chart becomes a sunburst by flipping
// `chart.type`. Each level is tinted with shades of its parent slice's hue.
var deviceColors = ['#1565C0', '#2E7D32', '#EF6C00'] // Mobile / Desktop / Tablet
var mobileOsColors = ['#0D47A1', '#1976D2', '#64B5F6'] // Mobile by OS
var iosColors = ['#1565C0', '#42A5F5', '#90CAF9'] // iOS versions
var desktopOsColors = ['#1B5E20', '#388E3C', '#66BB6A'] // Desktop by OS
var tabletOsColors = ['#E65100', '#FB8C00'] // Tablet by OS

var options = {
  series: [
    {
      name: 'Devices',
      data: [
        { x: 'Mobile', y: 55, drilldown: 'mobile' },
        { x: 'Desktop', y: 33, drilldown: 'desktop' },
        { x: 'Tablet', y: 12, drilldown: 'tablet' },
      ],
    },
  ],
  chart: {
    type: 'sunburst',
    height: 480,
  },
  colors: deviceColors,
  legend: {
    position: 'bottom',
  },
  title: {
    text: 'Website traffic by device',
    align: 'left',
  },
  subtitle: {
    text: 'The same series + drilldown.series config as a drilldown donut, rendered as one sunburst.',
    align: 'left',
  },
  plotOptions: {
    sunburst: {
      innerSize: '20%',
    },
  },
  stroke: {
    width: 1,
    colors: ['#fff'],
  },
  drilldown: {
    series: [
      {
        id: 'mobile',
        name: 'Mobile by OS',
        colors: mobileOsColors,
        data: [
          { x: 'iOS', y: 30, drilldown: 'mobile-ios' },
          { x: 'Android', y: 23 },
          { x: 'Other', y: 2 },
        ],
      },
      {
        id: 'mobile-ios',
        name: 'iOS Versions',
        colors: iosColors,
        data: [
          { x: 'iOS 17', y: 18 },
          { x: 'iOS 16', y: 9 },
          { x: 'iOS 15', y: 3 },
        ],
      },
      {
        id: 'desktop',
        name: 'Desktop by OS',
        colors: desktopOsColors,
        data: [
          { x: 'Windows', y: 20 },
          { x: 'macOS', y: 10 },
          { x: 'Linux', y: 3 },
        ],
      },
      {
        id: 'tablet',
        name: 'Tablet by OS',
        colors: tabletOsColors,
        data: [
          { x: 'iPadOS', y: 8 },
          { x: 'Android', y: 4 },
        ],
      },
    ],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Sunburst from Drilldown in Angular

Using ApexCharts with Angular

This Sunburst from Drilldown example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private deviceColors: any = ['#1565C0', '#2E7D32', '#EF6C00'];

  private mobileOsColors: any = ['#0D47A1', '#1976D2', '#64B5F6'];

  private iosColors: any = ['#1565C0', '#42A5F5', '#90CAF9'];

  private desktopOsColors: any = ['#1B5E20', '#388E3C', '#66BB6A'];

  private tabletOsColors: any = ['#E65100', '#FB8C00'];

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Devices',
              data: [
                { x: 'Mobile', y: 55, drilldown: 'mobile' },
                { x: 'Desktop', y: 33, drilldown: 'desktop' },
                { x: 'Tablet', y: 12, drilldown: 'tablet' },
              ],
            },
          ],
          chart: {
            type: 'sunburst',
            height: 480,
          },
          colors: this.deviceColors,
          legend: {
            position: 'bottom',
          },
          title: {
            text: 'Website traffic by device',
            align: 'left',
          },
          subtitle: {
            text: 'The same series + drilldown.series config as a drilldown donut, rendered as one sunburst.',
            align: 'left',
          },
          plotOptions: {
            sunburst: {
              innerSize: '20%',
            },
          },
          stroke: {
            width: 1,
            colors: ['#fff'],
          },
          drilldown: {
            series: [
              {
                id: 'mobile',
                name: 'Mobile by OS',
                colors: this.mobileOsColors,
                data: [
                  { x: 'iOS', y: 30, drilldown: 'mobile-ios' },
                  { x: 'Android', y: 23 },
                  { x: 'Other', y: 2 },
                ],
              },
              {
                id: 'mobile-ios',
                name: 'iOS Versions',
                colors: this.iosColors,
                data: [
                  { x: 'iOS 17', y: 18 },
                  { x: 'iOS 16', y: 9 },
                  { x: 'iOS 15', y: 3 },
                ],
              },
              {
                id: 'desktop',
                name: 'Desktop by OS',
                colors: this.desktopOsColors,
                data: [
                  { x: 'Windows', y: 20 },
                  { x: 'macOS', y: 10 },
                  { x: 'Linux', y: 3 },
                ],
              },
              {
                id: 'tablet',
                name: 'Tablet by OS',
                colors: this.tabletOsColors,
                data: [
                  { x: 'iPadOS', y: 8 },
                  { x: 'Android', y: 4 },
                ],
              },
            ],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Sunburst from Drilldown in Vue

Using ApexCharts with Vue

This Sunburst from Drilldown example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="sunburst"
        height="480"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// A sunburst reads the SAME `series` + `drilldown.series` config a drilldown
// donut uses, so an existing drilldown chart becomes a sunburst by flipping
// `chart.type`. Each level is tinted with shades of its parent slice's hue.
var deviceColors = ['#1565C0', '#2E7D32', '#EF6C00'] // Mobile / Desktop / Tablet
var mobileOsColors = ['#0D47A1', '#1976D2', '#64B5F6'] // Mobile by OS
var iosColors = ['#1565C0', '#42A5F5', '#90CAF9'] // iOS versions
var desktopOsColors = ['#1B5E20', '#388E3C', '#66BB6A'] // Desktop by OS
var tabletOsColors = ['#E65100', '#FB8C00'] // Tablet by OS

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Devices',
          data: [
            { x: 'Mobile', y: 55, drilldown: 'mobile' },
            { x: 'Desktop', y: 33, drilldown: 'desktop' },
            { x: 'Tablet', y: 12, drilldown: 'tablet' },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'sunburst',
          height: 480,
        },
        colors: deviceColors,
        legend: {
          position: 'bottom',
        },
        title: {
          text: 'Website traffic by device',
          align: 'left',
        },
        subtitle: {
          text: 'The same series + drilldown.series config as a drilldown donut, rendered as one sunburst.',
          align: 'left',
        },
        plotOptions: {
          sunburst: {
            innerSize: '20%',
          },
        },
        stroke: {
          width: 1,
          colors: ['#fff'],
        },
        drilldown: {
          series: [
            {
              id: 'mobile',
              name: 'Mobile by OS',
              colors: mobileOsColors,
              data: [
                { x: 'iOS', y: 30, drilldown: 'mobile-ios' },
                { x: 'Android', y: 23 },
                { x: 'Other', y: 2 },
              ],
            },
            {
              id: 'mobile-ios',
              name: 'iOS Versions',
              colors: iosColors,
              data: [
                { x: 'iOS 17', y: 18 },
                { x: 'iOS 16', y: 9 },
                { x: 'iOS 15', y: 3 },
              ],
            },
            {
              id: 'desktop',
              name: 'Desktop by OS',
              colors: desktopOsColors,
              data: [
                { x: 'Windows', y: 20 },
                { x: 'macOS', y: 10 },
                { x: 'Linux', y: 3 },
              ],
            },
            {
              id: 'tablet',
              name: 'Tablet by OS',
              colors: tabletOsColors,
              data: [
                { x: 'iPadOS', y: 8 },
                { x: 'Android', y: 4 },
              ],
            },
          ],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 520px;
  margin: 35px auto;
}
</style>

Sunburst from Drilldown in React

Using ApexCharts with React

This Sunburst from Drilldown example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// A sunburst reads the SAME `series` + `drilldown.series` config a drilldown
// donut uses, so an existing drilldown chart becomes a sunburst by flipping
// `chart.type`. Each level is tinted with shades of its parent slice's hue.
var deviceColors = ['#1565C0', '#2E7D32', '#EF6C00'] // Mobile / Desktop / Tablet
var mobileOsColors = ['#0D47A1', '#1976D2', '#64B5F6'] // Mobile by OS
var iosColors = ['#1565C0', '#42A5F5', '#90CAF9'] // iOS versions
var desktopOsColors = ['#1B5E20', '#388E3C', '#66BB6A'] // Desktop by OS
var tabletOsColors = ['#E65100', '#FB8C00'] // Tablet by OS

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Devices',
        data: [
          { x: 'Mobile', y: 55, drilldown: 'mobile' },
          { x: 'Desktop', y: 33, drilldown: 'desktop' },
          { x: 'Tablet', y: 12, drilldown: 'tablet' },
        ],
      },
    ],
    options: {
      chart: {
        type: 'sunburst',
        height: 480,
      },
      colors: deviceColors,
      legend: {
        position: 'bottom',
      },
      title: {
        text: 'Website traffic by device',
        align: 'left',
      },
      subtitle: {
        text: 'The same series + drilldown.series config as a drilldown donut, rendered as one sunburst.',
        align: 'left',
      },
      plotOptions: {
        sunburst: {
          innerSize: '20%',
        },
      },
      stroke: {
        width: 1,
        colors: ['#fff'],
      },
      drilldown: {
        series: [
          {
            id: 'mobile',
            name: 'Mobile by OS',
            colors: mobileOsColors,
            data: [
              { x: 'iOS', y: 30, drilldown: 'mobile-ios' },
              { x: 'Android', y: 23 },
              { x: 'Other', y: 2 },
            ],
          },
          {
            id: 'mobile-ios',
            name: 'iOS Versions',
            colors: iosColors,
            data: [
              { x: 'iOS 17', y: 18 },
              { x: 'iOS 16', y: 9 },
              { x: 'iOS 15', y: 3 },
            ],
          },
          {
            id: 'desktop',
            name: 'Desktop by OS',
            colors: desktopOsColors,
            data: [
              { x: 'Windows', y: 20 },
              { x: 'macOS', y: 10 },
              { x: 'Linux', y: 3 },
            ],
          },
          {
            id: 'tablet',
            name: 'Tablet by OS',
            colors: tabletOsColors,
            data: [
              { x: 'iPadOS', y: 8 },
              { x: 'Android', y: 4 },
            ],
          },
        ],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="sunburst"
          height={480}
        />
      </div>
    </div>
  )
}

export default ApexChart